@ cp @
load path=d:\tbk\tb5\g\ch5;

load a, aopt;
i=1;
k1=a[90];
do until i>450;   
   k2=LinInter(a,aopt[.,2],k1);
   ?k2;
   wait;
   k1=k2;
   i=i+1;
endo;


end;


/* LinInter: Linear Interpolation 
**
** Usage y=LinInter(xvec,yvec,x)
**
** Input: xvec: n times 1 vector, the domain of f(x)
**        yvec: n times 1 vector, f(xvec)
**           x: scalar
**
** Output: y=f(xvec[i])+((f(xvec[i+1]-f(xvec[i])/(xvec[i+1]-xvec[i]))*(x-xvec[i]),
**         where xvec[i]<=x<=xvec[i+1]
*/

proc(1)=LinInter(xvec,yvec,x);

  local i, n;
  n=rows(xvec);
  i=sumc(xvec.<=x);
  if i>=n; 
        retp(yvec[n]);
  else;
        retp(yvec[i]+((yvec[i+1]-yvec[i])/(xvec[i+1]-xvec[i]))*(x-xvec[i]));
  endif;

endp;

